---
title: EffectTiming.direction
slug: Web/API/EffectTiming/direction
tags:
  - API
  - Animation
  - EffectTiming
  - Experimental
  - KeyframeEffect
  - Property
  - Reference
  - Web Animations
  - animate
  - direction
  - waapi
  - web animations api
---
<div>{{ SeeCompatTable() }}{{ APIRef("Web Animations") }}</div>

<p>The <strong><code>direction</code></strong> property of the <a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a> dictionary {{domxref("EffectTiming")}} indicates an animation's playback direction along its timeline, as well as its behavior when it reaches the end of an iteration</p>

<div class="note">
<p>{{domxref("Element.animate()")}}, {{domxref("KeyframeEffectReadOnly.KeyframeEffectReadOnly", "KeyframeEffectReadOnly()")}}, and {{domxref("KeyframeEffect.KeyframeEffect", "KeyframeEffect()")}} all accept an object of timing properties including <code>direction.</code> The value of <code>direction</code> corresponds directly to {{domxref("AnimationEffectTimingReadOnly.direction")}} in {{domxref("AnimationEffectReadOnly.timing", "timing")}} objects returned by {{domxref("AnimationEffectReadOnly")}}, {{domxref("KeyframeEffectReadOnly")}}, and {{domxref("KeyframeEffect")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>timingProperties</em> = {
  direction: "normal" | "reverse" | "alternate" | "alternate-reverse"
};

<em>timingProperties</em>.direction = "normal" | "reverse" | "alternate" | "alternate-reverse";
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} which specifies the direction in which the animation should play as well as what to do when the playback reaches the end of the animation sequence in the current direction. It can take one of the following values, with the default being <code>"normal"</code>:</p>

<dl>
 <dt><code>"normal"</code></dt>
 <dd>The animation runs forwards, from beginning to end, in the way we experience the flow of time.</dd>
 <dt><code>"reverse</code>"</dt>
 <dd>The animation runs backwards, or "rewinds."</dd>
 <dt><code>"alternate"</code></dt>
 <dd>The animation switches direction after each iteration, going forward through the animation sequence the first iteration, then backward through the sequence the second iteration, and so forth.</dd>
 <dt><code>"alternate-reverse"</code></dt>
 <dd>Similar to "alternate", except the animation playback starts by going from the end of the animation sequence toward the beginning the first iteration, then goes forward during the second, and so forth.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the <a href="http://codepen.io/rachelnabors/pen/bEPdQr?editors=0010">Forgotten Key</a> example, Alice waves her arm up and down by passing her an <code>alternate</code> value for her <code>direction</code> property:</p>

<pre class="brush: js notranslate">// Get Alice's arm, and wave it up and down
document.getElementById("alice_arm").animate([
  { transform: 'rotate(10deg)' },
  { transform: 'rotate(-40deg)' }
], {
  easing: 'steps(2, end)',
  iterations: Infinity,
  direction: <strong>'alternate'</strong>,
  duration: 600
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Animations', '#enumdef-playbackdirection', 'direction' )}}</td>
   <td>{{Spec2('Web Animations')}}</td>
   <td>Editor's draft.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.EffectTiming.direction")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a></li>
 <li>{{domxref("Element.animate()")}}, {{domxref("KeyframeEffectReadOnly.KeyframeEffectReadOnly", "KeyframeEffectReadOnly()")}}, and {{domxref("KeyframeEffect.KeyframeEffect", "KeyframeEffect()")}} all accept an object of timing properties including this one.</li>
 <li>The value of this property corresponds to the one in {{domxref("AnimationEffectTimingReadOnly")}} (which is the {{domxref("AnimationEffectReadOnly.timing", "timing")}} object for {{domxref("AnimationEffectReadOnly")}}, {{domxref("KeyframeEffectReadOnly")}}, and {{domxref("KeyframeEffect")}}).</li>
 <li>CSS's <code><a href="/en-US/docs/Web/CSS/animation-direction">animation-direction</a></code></li>
</ul>
